import { Type } from '@angular/core';
import { Color, ColorRepresentation, MeshPhysicalMaterial, MeshPhysicalMaterialParameters, Texture, Vector2 } from 'three';
import { ThMeshStandardMaterial } from './ThMeshStandardMaterial';
import * as i0 from "@angular/core";
export declare class ThMeshPhysicalMaterial<T extends MeshPhysicalMaterial = MeshPhysicalMaterial, TARGS = MeshPhysicalMaterialParameters> extends ThMeshStandardMaterial<T, TARGS> {
    getType(): Type<MeshPhysicalMaterial>;
    set type(value: string);
    get type(): string | undefined;
    set defines(value: {
        [key: string]: any;
    });
    get defines(): {
        [key: string]: any;
    } | undefined;
    set clearcoat(value: number);
    get clearcoat(): number | undefined;
    set clearcoatMap(value: Texture | null);
    get clearcoatMap(): (Texture | null) | undefined;
    set clearcoatRoughness(value: number);
    get clearcoatRoughness(): number | undefined;
    set clearcoatRoughnessMap(value: Texture | null);
    get clearcoatRoughnessMap(): (Texture | null) | undefined;
    set clearcoatNormalScale(value: Vector2 | [x: number, y: number]);
    get clearcoatNormalScale(): Vector2 | undefined;
    set clearcoatNormalMap(value: Texture | null);
    get clearcoatNormalMap(): (Texture | null) | undefined;
    set reflectivity(value: number);
    get reflectivity(): number | undefined;
    set ior(value: number);
    get ior(): number | undefined;
    set sheen(value: number);
    get sheen(): number | undefined;
    set sheenColor(value: Color | [color: ColorRepresentation]);
    get sheenColor(): Color | undefined;
    set sheenColorMap(value: Texture | null);
    get sheenColorMap(): (Texture | null) | undefined;
    set sheenRoughness(value: number);
    get sheenRoughness(): number | undefined;
    set sheenRoughnessMap(value: Texture | null);
    get sheenRoughnessMap(): (Texture | null) | undefined;
    set transmission(value: number);
    get transmission(): number | undefined;
    set transmissionMap(value: Texture | null);
    get transmissionMap(): (Texture | null) | undefined;
    set thickness(value: number);
    get thickness(): number | undefined;
    set thicknessMap(value: Texture | null);
    get thicknessMap(): (Texture | null) | undefined;
    set attenuationDistance(value: number);
    get attenuationDistance(): number | undefined;
    set attenuationColor(value: Color | [color: ColorRepresentation]);
    get attenuationColor(): Color | undefined;
    set specularIntensity(value: number);
    get specularIntensity(): number | undefined;
    set specularColor(value: Color | [color: ColorRepresentation]);
    get specularColor(): Color | undefined;
    set specularIntensityMap(value: Texture | null);
    get specularIntensityMap(): (Texture | null) | undefined;
    set specularColorMap(value: Texture | null);
    get specularColorMap(): (Texture | null) | undefined;
    set iridescenceMap(value: Texture | null);
    get iridescenceMap(): (Texture | null) | undefined;
    set iridescenceIOR(value: number);
    get iridescenceIOR(): number | undefined;
    set iridescence(value: number);
    get iridescence(): number | undefined;
    set iridescenceThicknessRange(value: [number, number]);
    get iridescenceThicknessRange(): [number, number] | undefined;
    set iridescenceThicknessMap(value: Texture | null);
    get iridescenceThicknessMap(): (Texture | null) | undefined;
    set anisotropy(value: number);
    get anisotropy(): number | undefined;
    set anisotropyRotation(value: number);
    get anisotropyRotation(): number | undefined;
    set anisotropyMap(value: Texture | null);
    get anisotropyMap(): (Texture | null) | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThMeshPhysicalMaterial<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThMeshPhysicalMaterial<any, any>, "th-meshPhysicalMaterial", never, { "type": { "alias": "type"; "required": false; }; "defines": { "alias": "defines"; "required": false; }; "clearcoat": { "alias": "clearcoat"; "required": false; }; "clearcoatMap": { "alias": "clearcoatMap"; "required": false; }; "clearcoatRoughness": { "alias": "clearcoatRoughness"; "required": false; }; "clearcoatRoughnessMap": { "alias": "clearcoatRoughnessMap"; "required": false; }; "clearcoatNormalScale": { "alias": "clearcoatNormalScale"; "required": false; }; "clearcoatNormalMap": { "alias": "clearcoatNormalMap"; "required": false; }; "reflectivity": { "alias": "reflectivity"; "required": false; }; "ior": { "alias": "ior"; "required": false; }; "sheen": { "alias": "sheen"; "required": false; }; "sheenColor": { "alias": "sheenColor"; "required": false; }; "sheenColorMap": { "alias": "sheenColorMap"; "required": false; }; "sheenRoughness": { "alias": "sheenRoughness"; "required": false; }; "sheenRoughnessMap": { "alias": "sheenRoughnessMap"; "required": false; }; "transmission": { "alias": "transmission"; "required": false; }; "transmissionMap": { "alias": "transmissionMap"; "required": false; }; "thickness": { "alias": "thickness"; "required": false; }; "thicknessMap": { "alias": "thicknessMap"; "required": false; }; "attenuationDistance": { "alias": "attenuationDistance"; "required": false; }; "attenuationColor": { "alias": "attenuationColor"; "required": false; }; "specularIntensity": { "alias": "specularIntensity"; "required": false; }; "specularColor": { "alias": "specularColor"; "required": false; }; "specularIntensityMap": { "alias": "specularIntensityMap"; "required": false; }; "specularColorMap": { "alias": "specularColorMap"; "required": false; }; "iridescenceMap": { "alias": "iridescenceMap"; "required": false; }; "iridescenceIOR": { "alias": "iridescenceIOR"; "required": false; }; "iridescence": { "alias": "iridescence"; "required": false; }; "iridescenceThicknessRange": { "alias": "iridescenceThicknessRange"; "required": false; }; "iridescenceThicknessMap": { "alias": "iridescenceThicknessMap"; "required": false; }; "anisotropy": { "alias": "anisotropy"; "required": false; }; "anisotropyRotation": { "alias": "anisotropyRotation"; "required": false; }; "anisotropyMap": { "alias": "anisotropyMap"; "required": false; }; }, {}, never, ["*"], false, never>;
}
