import { EventEmitter, NgZone, OnInit, PipeTransform } from '@angular/core';
import { Loader } from 'three';
import { ThAnimationLoopService } from '../renderer/th-animation-loop.service';
import { LazyObject3DProxy } from './LazyObject3dProxy';
import { ThLoader } from './ThLoaderBase';
import * as i0 from "@angular/core";
interface AsyncLoader<T = any> extends Loader {
    loadAsync(url: string, onProgress?: (event: ProgressEvent) => void): Promise<T>;
}
type Awaited<T> = T extends PromiseLike<infer U> ? U : T;
export declare abstract class ThAsyncLoaderService<T extends AsyncLoader> extends ThLoader<T> {
    load(...args: Parameters<T['loadAsync']>): ReturnType<T['loadAsync']>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThAsyncLoaderService<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ThAsyncLoaderService<any>>;
}
export declare abstract class ThAsyncLoaderBasePipe<T extends AsyncLoader> implements PipeTransform {
    protected abstract service: ThAsyncLoaderService<T>;
    private animationLoop;
    constructor();
    transform(...args: Parameters<T['loadAsync']>): Promise<any>;
}
export declare abstract class ThAsyncLoaderBaseDirective<T extends AsyncLoader> implements OnInit {
    protected host: {
        objRef: any;
    };
    protected zone: NgZone;
    protected abstract service: ThAsyncLoaderService<T>;
    protected abstract getRefFromResponse(response: Awaited<ReturnType<T['loadAsync']>>): any;
    protected initialized: boolean;
    protected _url?: Parameters<T['loadAsync']>[0];
    protected onLoaded$?: EventEmitter<Awaited<ReturnType<T['loadAsync']>>>;
    protected onProgress$?: EventEmitter<ProgressEvent>;
    protected proxy: LazyObject3DProxy;
    protected animationLoop: ThAnimationLoopService;
    set url(url: Parameters<T['loadAsync']>[0] | undefined);
    get url(): Parameters<T['loadAsync']>[0] | undefined;
    get onLoaded(): EventEmitter<Awaited<ReturnType<T["loadAsync"]>>>;
    get onProgress(): EventEmitter<ProgressEvent<EventTarget>>;
    constructor(host: {
        objRef: any;
    }, zone: NgZone);
    ngOnInit(): void;
    protected load(): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThAsyncLoaderBaseDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ThAsyncLoaderBaseDirective<any>, never, never, { "url": { "alias": "url"; "required": false; }; }, { "onLoaded": "onLoaded"; "onProgress": "onProgress"; }, never, never, false, never>;
}
export {};
